unit errormsg;

{ By Paul Toth }
{ PaulToth@compuserve.com }
{ http://ourworld.compuserve.com/homepages/paultoth }
{ Tothpaul@Mygale.org }
{ http://www.mygale.org/~tothpaul }

{ This is a beta version of my TCPIP suite }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TErrorMsg = class(TComponent)
  private
   fMessages:TStringList;
   Procedure SetMessages(Value:TStringList);
   Function GetError(Name:String):string;
   Function GetErrorNumber(Index:Integer):string;
  protected
   Constructor Create(AOwner:TComponent); override;
   Destructor Destroy; override;
  public
   Procedure ShowError(Name:string);
   Property Error[Name:string]:string read GetError;
   Property ErrorNumber[Index:Integer]:string read GetErrorNumber;
  published
   Property Messages:TStringList read fMessages write SetMessages;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MySoft', [TErrorMsg]);
end;

Constructor TErrorMsg.Create(AOwner:TComponent);
 begin
  inherited Create(AOwner);
  fMessages:=TStringList.Create;
 end;

Destructor TErrorMsg.Destroy;
 begin
  fMessages.Free;
  inherited Destroy;
 end;

Procedure TErrorMsg.SetMessages(Value:TStringList);
 begin
  fMessages.Assign(Value);
 end;

Function TErrorMsg.GetError(Name:string):string;
 begin
  Result:=fMessages.Values[Name];
  if Result='' then Result:=Name;
 end;

Function TErrorMsg.GetErrorNumber(Index:Integer):string;
 begin
  Result:=GetError(IntToStr(Index));
 end;

Procedure TErrorMsg.ShowError(Name:String);
 begin
  MessageDlg(Error[Name],mtWarning,[mbOk],0);
 end;

end.
