unit tcpip0;

{ By Paul Toth }
{ PaulToth@compuserve.com }
{ http://ourworld.compuserve.com/homepages/paultoth }
{ Tothpaul@Mygale.org }
{ http://www.mygale.org/~tothpaul }

{ This is a beta version of my TCPIP suite }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}interface

uses
 IniFiles, Windows, SysUtils;

Type
 TConfig=class(TIniFile)
 private
  Function GetConfigName:string;
  Function GetHomePage:string;
  Function GetUpper:boolean;
  Function GetSMTPServer:string;
  Function GetUserName:string;
  Function GetEMail:String;
  Function GetPOP3Server:string;
  Function GetAccount:string;
  Function GetPassword:string;
  Procedure SetConfigName(Value:string);
  Procedure SetHomePage(Value:string);
  Procedure SetUpper(Value:boolean);
  Procedure SetSMTPServer(Value:string);
  Procedure SetUserName(Value:string);
  Procedure SetEMail(Value:string);
  Procedure SetPOP3Server(Value:string);
  Procedure SetAccount(Value:string);
  Procedure SetPassword(Value:string);
 public
  Property ConfigName:string read GetConfigName write SetConfigName;
   Property HomePage:string read GetHomePage write SetHomePage;
   Property Upper:boolean read GetUpper write SetUpper;
  Property SMTPServer:String read GetSMTPServer write SetSMTPServer;
   Property UserName:string read GetUserName write SetUserName;
   Property EMail:string read GetEMail write SetEMail;
  Property POP3Server:String read GetPOP3Server write SetPOP3Server;
   Property Account:string read GetAccount write SetAccount;
   Property PassWord:string read GetPassword write SetPassword;
 end;

Var
 Config:TConfig;

implementation

{ Password }

function syskey:string;
 var
  sysinfo:TSystemInfo;
 begin
  GetSystemInfo(sysinfo);
  with sysinfo do
   Result:=IntToHex(dwProcessorType,8)+IntToHex(wProcessorLevel,4);
 end;

function encode(pass,key:string):string;
 var
  p,k:byte;
 begin
  key:=key+syskey;
  k:=1;
  Result:='';
  for p:=1 to length(pass) do begin
   pass[p]:=chr(ord(pass[p]) xor ord(key[k]));
   inc(k); if k>length(key) then k:=1;
   Result:=Result+IntToHex(ord(pass[p]),2);
  end;
 end;

function HexToInt(Hex:string):integer;
 const
  Hx:array[0..$F] of char='0123456789ABCDEF';
 begin
  Result:=16*(Pos(Hex[1],Hx)-1)+Pos(Hex[2],Hx)-1;
 end;

function decode(code,key:string):string;
 var
  c,k:byte;
  l:char;
 begin
  key:=key+syskey;
  c:=1;
  k:=1;
  Result:='';
  while c<length(code) do begin
   l:=chr(HexToInt(copy(code,c,2)) xor ord(key[k])); inc(c,2);
   inc(k); if k>length(key) then k:=1;
   Result:=Result+l;
  end;
 end;

{ TConfig }
Function TConfig.GetConfigName:string;
 begin
  Result:=ReadString('TCP','Config','default');
 end;

Function TConfig.GetHomePage:string;
 begin
  Result:=ReadString('cfg_'+ConfigName,'HomePage','http://');
  if Upper then Result:=UpperCase(Result);
 end;

Function TConfig.GetUpper:boolean;
 begin
  Result:=ReadBool('cfg_'+ConfigName,'UpperCase',False);
 end;

Function TConfig.GetSMTPServer:string;
 begin
  Result:=ReadString('cfg_'+ConfigName,'SMTPServer','127.0.0.1');
 end;

Function TConfig.GetUserName:string;
 begin
  Result:=ReadString('cfg_'+ConfigName,'User','');
 end;

Function TConfig.GetEMail:String;
 begin
  Result:=ReadString('cfg_'+ConfigName,'EMail','');
 end;

Function TConfig.GetPOP3Server:string;
 begin
  Result:=ReadString('cfg_'+ConfigName,'POP3Server','127.0.0.1');
 end;

Function TConfig.GetAccount:string;
 begin
  Result:=ReadString('cfg_'+ConfigName,'Account','');
 end;

Function TConfig.GetPassword:string;
 begin
  Result:=Decode(ReadString('cfg_'+ConfigName,'Password',''),POP3Server+Account);
 end;

Procedure TConfig.SetConfigName(Value:string);
 begin
  WriteString('TCP','Config',Value);
 end;

Procedure TConfig.SetHomePage(Value:string);
 begin
  WriteString('cfg_'+ConfigName,'HomePage',Value);
 end;

Procedure TConfig.SetUpper(Value:boolean);
 begin
  WriteBool('cfg_'+ConfigName,'UpperCase',Value);
 end;

Procedure TConfig.SetSMTPServer(Value:string);
 begin
  WriteString('cfg_'+ConfigName,'SMTPServer',Value);
 end;

Procedure TConfig.SetUserName(Value:string);
 begin
  WriteString('cfg_'+ConfigName,'User',Value);
 end;

Procedure TConfig.SetEMail(Value:string);
 begin
  WriteString('cfg_'+ConfigName,'EMail',Value);
 end;

Procedure TConfig.SetPOP3Server(Value:string);
 begin
  WriteString('cfg_'+ConfigName,'POP3Server',Value);
 end;

Procedure TConfig.SetAccount(Value:string);
 begin
  WriteString('cfg_'+ConfigName,'Account',Value);
 end;

Procedure TConfig.SetPassword(Value:string);
 begin
  WriteString('cfg_'+ConfigName,'Password',EnCode(Value,POP3Server+Account));
 end;

end.
