unit tcpip1;

{ By Paul Toth }
{ PaulToth@compuserve.com }
{ http://ourworld.compuserve.com/homepages/paultoth }
{ Tothpaul@Mygale.org }
{ http://www.mygale.org/~tothpaul }

{ This is a beta version of my TCPIP suite }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sockets, ExtCtrls, url, StdCtrls, Buttons, errormsg, ComCtrls,IniFiles,
  Menus, TcpIp0;

type
  THTTP = class(TForm)
    httpSocket: TSocket;
    Url1: TUrl;
    Panel1: TPanel;
    OpenMail: TSpeedButton;
    Stop: TSpeedButton;
    TcpError: TErrorMsg;
    StatusBar: TStatusBar;
    Reload: TSpeedButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Close1: TMenuItem;
    Display1: TMenuItem;
    DisplayOptions: TMenuItem;
    Home: TSpeedButton;
    Display: TMemo;
    SpeedButton1: TSpeedButton;
    procedure Url1OnUrl(Sender: TObject);
    procedure httpSocketConnect(Sender: TObject; ASocket: Integer);
    procedure httpSocketRead(Sender: TObject; ASocket: Integer);
    procedure httpSocketError(Sender: TObject; Error: Word;
      ASocket: Integer; Event: Word);
    procedure httpSocketClose(Sender: TObject; ASocket: Integer);
    procedure httpSocketWrite(Sender: TObject; ASocket: Integer);
    procedure NewMailClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DisplayOptionsClick(Sender: TObject);
    procedure OpenMailClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HomeClick(Sender: TObject);
  private
    { Dclarations prives }
    tag:string;
    readtitle:boolean;
    WebTitle:string;
    procedure addHtml(s:string);
    procedure PerformTag;
  public
    { Dclarations publiques }
  end;

var
  HTTP: THTTP;

implementation

uses tcpip2, cfgtcpip, tcpip3;

{$R *.DFM}

procedure THTTP.Url1OnUrl(Sender: TObject);
begin
 httpSocket.Active:=False;
 httpSocket.Active:=True;
 StatusBar.SimpleText:='Connection to server '+Url1.Host;
 httpSocket.Call(Url1.Host);
end;

procedure THTTP.httpSocketConnect(Sender: TObject; ASocket: Integer);
begin
 Tag:='';
 httpSocket.WriteLn(ASocket,'GET '+Url1.Path+' HTTP/1.0');
 httpSocket.WriteLn(ASocket,'');
 StatusBar.SimpleText:='Request '+Url1.Path+' on '+Url1.Host;
 Display.Clear;
 Stop.Enabled:=True;
end;

procedure THTTP.PerformTag;
 const
  tags='/HTML/HEAD/TITLE/BODY';
 var
  tagname:string;
  p:byte;
 begin
  p:=2;
  while tag[p]=' ' do inc(p);
  tagname:='';
  while not (tag[p] in [' ','>']) do begin tagname:=tagname+upcase(tag[p]); inc(p); end;
//  Display.Lines.Add('->'+Tag+'->'+TagName);

// Headers
  if tagname[1]='/' then p:=2 else p:=1;
  if (length(tagname)=p+1) and (tagname[p]='H') then begin
   if p=2 then begin
    p:=10;
 //   Display.DefAttributes.Color:=clBlack;
   end else begin
//    Display.DefAttributes.Color:=clRed;
    case tagname[p+1] of
     '1': p:=20;
     '2': p:=18;
     '3': p:=16;
     '4': p:=14;
     '5': p:=12;
    end;
   end;
//   Display.DefAttributes.Height:=p;
   tag:='';
   exit;
  end;

  p:=pos(tagname,tags);
  case p of
   1:  { /html };
   2:  Display.Clear; { html }
   6:  { /head };
   7:  { head };
   11:  begin Caption:=WebTitle+' - Web browser ['+Config.ConfigName+']'; ReadTitle:=False; end;{ /title }
   12:  begin WebTitle:=''; ReadTitle:=True; end;{ title }
   17: { /BODY };
   18: Display.clear; { Body }
   else Display.Lines.add(Tag+' '+IntToStr(p));
  end;
  tag:='';
 end;

procedure THTTP.AddHtml(s:string);
 var
  p:byte;

  procedure LineOut(s:string);
   begin
    if ReadTitle then
     Webtitle:=WebTitle+' '+s
    else
     Display.Lines.add(s);      // just add text
   end;

 begin
  repeat
   if length(tag)>0 then begin // reading a tag
    p:=pos('>',s);
    if p=0 then begin  // no ended yet
     tag:=tag+s;
     exit;
    end else begin
     tag:=tag+copy(s,1,p);     // end tag
     performtag;               // do it
     s:=copy(s,p+1,length(s)); // text left
    end;
   end;

   p:=pos('<',s);              // another tag ?
   if p=0 then begin           // no
    LineOut(s);
    exit;
   end else begin              // yes
    if p>1 then LineOut(copy(s,1,p-1)); // text before tag
    s:=copy(s,p,length(s));    // remove text
    p:=pos('>',s);             // end of tag ?
    if p=0 then begin          // whe are reading a tag
     tag:=s;
     exit;
    end else begin
     tag:=copy(s,1,p);
     performtag;
     s:=copy(s,p+1,length(s)); // we will loop !
    end;
   end;
  until s='';
 end;

procedure THTTP.httpSocketRead(Sender: TObject; ASocket: Integer);
Var
 s:string;
begin
 StatusBar.SimpleText:='Reading data...';
 While httpSocket.ReadLn(Asocket,s)>=0 do AddHtml(s);
end;

procedure THTTP.httpSocketError(Sender: TObject; Error: Word;
  ASocket: Integer; Event: Word);
var
 msg:string;
begin
 case Event of
  0: msg:='Read  ';
  1: msg:='Write ';
  else msg:='';
 end;
 msg:=msg+TcpError.ErrorNumber[Error]+' on socket '+IntToStr(ASocket);
 Display.Lines.Add(msg);
end;

procedure THTTP.httpSocketClose(Sender: TObject; ASocket: Integer);
begin
 Stop.Enabled:=False;
 StatusBar.SimpleText:='Ready';
end;

procedure THTTP.httpSocketWrite(Sender: TObject; ASocket: Integer);
begin
 display.lines.add('write');
end;

procedure THTTP.NewMailClick(Sender: TObject);
begin
 if SMTP=nil then SMTP:=TSMTP.Create(Application);
 SMTP.show;
end;

procedure THTTP.FormCreate(Sender: TObject);
begin
 Config:=TConfig.Create(ChangeFileExt(Application.ExeName,'.ini'));
 Caption:='Web browser ['+Config.ConfigName+']';
 Url1.Text:=Config.HomePage;
end;

procedure THTTP.DisplayOptionsClick(Sender: TObject);
begin
 try
  ConfigForm:=TConfigForm.Create(Application);
  ConfigForm.ConfigHTTP.Show;
  ConfigForm.ShowModal;
 finally
  ConfigForm.Free;
 end;
 Caption:='Web browser ['+Config.ConfigName+']';
end;

procedure THTTP.OpenMailClick(Sender: TObject);
begin
 if POP3=nil then POP3:=TPOP3.Create(Application);
 POP3.show;
end;

procedure THTTP.FormDestroy(Sender: TObject);
begin
 Config.Free;
end;

procedure THTTP.HomeClick(Sender: TObject);
begin
 Url1.Text:=Config.HomePage;
 Reload.click;
end;

end.
