unit tcpip2;

{ By Paul Toth }
{ PaulToth@compuserve.com }
{ http://ourworld.compuserve.com/homepages/paultoth }
{ Tothpaul@Mygale.org }
{ http://www.mygale.org/~tothpaul }

{ This is a beta version of my TCPIP suite }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}interface

{ SMTP step by step :

[TSocket.Active:=True]
 wsaStartup
 Socket

[ TSocket.Events=[evConnect,evRead,evClose)]
 wsaASyncSelect(connect,Read,Close)

[TSocker.Call(Server IP Address)]
 Connect(Server IP Address)

Now, the component receive windows messages (wm_user) (S=Send, R=Receive) :

[TSocket.OnError]
 R: Nonblocking socket for connect (WSAEWOULDBLOCK)
 this is a "normal" error cause my component doesn't use Blocking Calls

[TSocket.OnConnect]
 S: HELO ClientName <CRLF>

[TSocket.OnRead]
 R: 220 ServerName
 S: RSET <CRLF>

 R: 250 OK
 S: MAIL FROM:<Sender@ServerName> <CRLF>

 R: 250 OK
 S: RCPT TO:<Receiver@ServerName> <CRLF>

 R: 250 OK
 S: DATA <CRLF>

 R: 354 Enter mail body. End mail with a '.' in column 1 on a line by itself.
 S: Date: CurrentDate <CRLF>
 S: From: Sender <CRLF>
 S: To: Receiver <CRLF>
 S: Subject: Subject <CRLF>
 S: <CRLF>
 S: TextToSend
 S: .<CRLF>

 R: 250 OK
 S: QUIT <CRLF>

 R 220 ServerInfo

[TSocket.OnClose]
 Now you can send an other mail

[TSocket.Active:=False]
 ShutDown(2)
 CloseSocket
 wsaCleanup
}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sockets, ComCtrls, StdCtrls, ExtCtrls, Menus;

type
  TSMTP = class(TForm)
    Panel1: TPanel;
    Msg: TMemo;
    Label2: TLabel;
    ToUser: TEdit;
    btSend: TButton;
    StatusBar: TStatusBar;
    smtpSocket: TSocket;
    Log: TMemo;
    Label3: TLabel;
    Subject: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Quit1: TMenuItem;
    Message1: TMenuItem;
    MessageOptions: TMenuItem;
    N1: TMenuItem;
    New1: TMenuItem;
    N2: TMenuItem;
    Send1: TMenuItem;
    procedure smtpSocketClose(Sender: TObject; ASocket: Integer);
    procedure smtpSocketConnect(Sender: TObject; ASocket: Integer);
    procedure btSendClick(Sender: TObject);
    procedure smtpSocketRead(Sender: TObject; ASocket: Integer);
    procedure smtpSocketError(Sender: TObject; Error: Word;
      ASocket: Integer; Event: Word);
    procedure MessageOptionsClick(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    Status:(stOver,stHelo,stRset,stMail,stRcpt,stData,stText,stQuit);
    Server:string;
    YourName:string;
    YourEMail:string;
  public
    { Dclarations publiques }
    Procedure ReadIni;
  end;

var
  SMTP: TSMTP;

implementation

uses
 tcpip0, cfgtcpip, tcpip1;

{$R *.DFM}

procedure TSMTP.btSendClick(Sender: TObject);
begin
 Log.Clear;
 ReadIni;
 if (server='')or(YourEMail='') then begin
  MessageOptions.click;
  ReadIni;
  if (server='')or(YourEMail='') then exit;
 end;
 if Status<>stOver then begin
  ShowMessage('Mailler not ready to send');
  exit;
 end;
 btSend.enabled:=False;
 StatusBar.SimpleText:='Connexion to Host '+Server;
 Status:=stOver;
 smtpSocket.Active:=True;
 smtpSocket.Call(Server);
end;

procedure TSMTP.smtpSocketClose(Sender: TObject; ASocket: Integer);
begin
 btSend.Enabled:=True;
 Status:=stOver;
 smtpSocket.Active:=False;
end;

procedure TSMTP.smtpSocketConnect(Sender: TObject; ASocket: Integer);
begin
 Status:=stHelo;
 smtpSocket.WriteLn(ASocket,'HELO DELPHI2.WINDOWS95');
 Log.Lines.Add('>HELO DELHI2.WINDOWS95');
end;

procedure TSMTP.smtpSocketRead(Sender: TObject; ASocket: Integer);
var
 s:string;
begin
 smtpSocket.ReadLn(ASocket,s); if s='' then s:='999';
 StatusBar.SimpleText:=s;
 Log.Lines.Add(s);

 case StrToInt(copy(s,1,3)) of
  220,
  250,
  354   : inc(Status);
  else  begin log.lines.add('<!> cancel connexion on '+s); Status:=stQuit; end;
 end;

 case status of
  stRset:log.lines.add('>RSET');
  stMail:log.lines.add('>MAIL FROM:<'+YourEMail+'>');
  stRcpt:log.lines.add('>RCPT TO:<'+ToUser.Text+'>');
  stData:log.lines.add('>DATA');
  stText:log.lines.add('>"message"');
  stQuit:log.lines.add('>QUIT');
 end;

 case Status of
  stRset: smtpSocket.WriteLn(ASocket,'RSET');
  stMail: smtpSocket.WriteLn(ASocket,'MAIL FROM:<'+YourEMail+'>');
  stRcpt: smtpSocket.WriteLn(ASocket,'RCPT TO:<'+ToUser.Text+'>');
  stData: smtpSocket.WriteLn(ASocket,'DATA');
  stText: With smtpSocket do begin
           WriteLn(ASocket,'Date: '+FormatDateTime('dddd dd mmm yyyy',now));
           WriteLn(Asocket,'From: '+YourName+' <'+YourEMail+'>');
           WriteLn(Asocket,'To: '+ToUser.Text);
           WriteLn(ASocket,'Subject: '+Subject.Text);
           WriteLn(ASocket,'');
           WriteLn(ASocket,Msg.Text);
           WriteLn(ASocket,'.');
          end;
  stQuit: smtpSocket.WriteLn(ASocket,'QUIT');
 end;
end;

procedure TSMTP.smtpSocketError(Sender: TObject; Error: Word;
  ASocket: Integer; Event: Word);
begin
 if Error=10035 then
  StatusBar.SimpleText:='Waiting fo reply...'
 else begin
  Log.Lines.Add('<!>'+HTTP.TcpError.ErrorNumber[Error]+' on socket '+IntToStr(ASocket));
  smtpSocket.Active:=False;
  btSend.Enabled:=True;
 end;
end;

procedure TSMTP.MessageOptionsClick(Sender: TObject);
begin
 Try
  ConfigForm:=TConfigForm.create(Application);
  ConfigForm.ConfigSMTP.Show;
  ConfigForm.ShowModal;
 Finally
  ConfigForm.Free;
 end;
end;

procedure TSMTP.Quit1Click(Sender: TObject);
begin
 Release;
end;

procedure TSMTP.New1Click(Sender: TObject);
begin
 Subject.Text:='';
 Msg.text:='';
end;

procedure TSMTP.FormDestroy(Sender: TObject);
begin
 SMTP:=nil; { see tcpip1 : NewMailClick() }
end;

procedure TSMTP.ReadIni;
begin
 Server:=Config.SMTPServer;
 YourName:=Config.UserName;
 YourEMail:=config.EMail;
end;

end.
