unit tcpip3;

{ By Paul Toth }
{ PaulToth@compuserve.com }
{ http://ourworld.compuserve.com/homepages/paultoth }
{ Tothpaul@Mygale.org }
{ http://www.mygale.org/~tothpaul }

{ This is a beta version of my TCPIP suite }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Buttons, sockets, StdCtrls, ExtCtrls, ComCtrls, Grids;

type
  TPOPStatus=(
   stNone, { no active host  }
   stOPEN, { receive connect }
   stUSER, { USER <username> }
   stPASS, { PASS <password> }
   stSTAT, { STAT            }
   stUIDL, { UIDL x          }
   stLIST, { LIST            }
   stRETR, { RETR x          }
   stHEAD, { reading header  }
   stDATA, { reading data    }
   stDELE, { DELE x          }
   stQUIT  { QUIT            }
  );

  TPOP3 = class(TForm)
    Panel1: TPanel;
    Message: TMemo;
    pop3Socket: TSocket;
    SpeedButton1: TSpeedButton;
    StatusBar: TStatusBar;
    MainMenu1: TMainMenu;
    Messages: TMenuItem;
    MessageOptions: TMenuItem;
    MsgList: TStringGrid;
    N1: TMenuItem;
    About1: TMenuItem;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Supprimer: TCheckBox;
    SpeedButton4: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure MessageOptionsClick(Sender: TObject);
    procedure pop3SocketConnect(Sender: TObject; ASocket: Integer);
    procedure pop3SocketError(Sender: TObject; Error: Word;
      ASocket: Integer; Event: Word);
    procedure pop3SocketRead(Sender: TObject; ASocket: Integer);
    procedure pop3SocketClose(Sender: TObject; ASocket: Integer);
    procedure OptionsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MsgListClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Dclarations prives }
    Server:string;
    Account:string;
    Password:string;
    Status:TPOPStatus;
    MsgCount:word;
    ReadMsg:word;
    MsgHead:TStringList;
    MsgData:TStringList;
    procedure readini;
    Procedure RegisterMsg;
  public
    { Dclarations publiques }
  end;

var
  POP3: TPOP3;

implementation

uses tcpip0,tcpip1, cfgtcpip, tcpip2;

{$R *.DFM}

procedure TPOP3.ReadIni;
 begin
  Server:=config.POP3Server;
  Account:=config.Account;
  Password:=config.Password;
 end;

procedure TPOP3.SpeedButton1Click(Sender: TObject);
Var
 i:integer;
begin
// MsgList.Clear;
 For i:=1 to MsgList.RowCount-1 do begin
  TStringList(MsgList.Objects[0,i]).Free; // MsgHead
  MsgList.Objects[0,i]:=nil;
  TStringList(MsgList.Objects[1,i]).Free; // MsgData
  MsgList.Objects[1,i]:=nil;
 end;
 MsgList.Rowcount:=2;
 MsgList.Rows[1].Clear;

 ReadIni;
 if (Server='')or(Account='') then begin
  MessageOptions.Click;
  ReadIni;
  if (Server='')or(Account='') then exit;
 end;
 Status:=stNone;
 pop3Socket.Active:=True;
 pop3Socket.Call(Server);
 StatusBar.SimpleText:='Calling '+Server+'...';
end;


procedure TPOP3.MessageOptionsClick(Sender: TObject);
begin
 try
  ConfigForm:=TConfigForm.Create(Application);
  ConfigForm.ConfigPOP3.Show;
  ConfigForm.ShowModal;
 finally
  ConfigForm.Free;
 end;
end;

procedure TPOP3.pop3SocketConnect(Sender: TObject; ASocket: Integer);
begin
 Status:=stOPEN;
 StatusBar.panels.Items[0].Text:='Host found...';
end;

procedure TPOP3.pop3SocketError(Sender: TObject; Error: Word;
  ASocket: Integer; Event: Word);
begin
 case Status of
  stNONE : ShowMessage('Host not found (#'+IntToStr(Error)+')');
  else ShowMessage('Socket error #'+IntToStr(Error));
  end;
 pop3Socket.Active:=False;
end;

procedure TPOP3.RegisterMsg;
 Function HeadValue(Name:string):string;
  Var
   i,j:integer;
  begin
   For i:=0 to MsgHead.Count-1 do begin
    Result:=MsgHead[i];
    if UpperCase(Copy(Result,1,Length(Name)))=Name then begin
     j:=Length(Name)+1;
     While (j<Length(Result)) and (Result[j]=' ') do inc(j);
     if Result[j]=':' then inc(j);
     While (j<Length(Result)) and (Result[j]=' ') do inc(j);
     Result:=Copy(Result,j,Length(Result));
     exit;
    end;
   end;
   Result:='?';
  end;
 begin
  MsgList.RowCount:=ReadMsg+1;
  MsgList.Rows[ReadMsg].Add(HeadValue('FROM'));
  MsgList.Rows[ReadMsg].Add(HeadValue('SUBJECT'));
  MsgList.Rows[ReadMsg].Add(HeadValue('DATE'));
  MsgList.Objects[0,ReadMsg]:=MsgHead;
  MsgList.Objects[1,ReadMsg]:=MsgData;
  MsgHead:=TStringList.Create;
  MsgData:=TStringList.Create;
 end;

procedure TPOP3.pop3SocketRead(Sender: TObject; ASocket: Integer);
var
 s:string;

 procedure Reply(NewStatus:TPOPStatus; Info,Request:string);
  var
   p:word;
  begin
   Status:=NewStatus;
   StatusBar.Panels.Items[0].Text:=Info;
   p:=pos(#10,s); if p=0 then p:=pos(#13,s);
   while p>0 do begin
    if s[p+1] in [#13,#10] then inc(p);
    s:=Copy(s,p+1,length(s));
    p:=pos(#10,s); if p=0 then p:=pos(#13,s);
   end;
   pop3Socket.WriteLn(ASocket,Request);
  end;

 Function MailCount:word;
  var
   p:byte;
  begin
   Result:=0;
   p:=pos(' ',s); if p=0 then exit;
   while (p<length(s))and(s[p+1] in ['0'..'9']) do begin
    inc(p);
    Result:=10*result+(ord(s[p])-ord('0'));
   end;
  end;

begin
 While pop3Socket.ReadLn(ASocket,s)>=0 do begin

  if (s='') and (Status<>stHead) then Continue;

  Case status of
   stOPEN : begin // username
             if s[1]='-' then begin
              ShowMessage('Connexion refused'#13#10+s);
              Reply(stQUIT,'Close connexion','QUIT');
             end else begin
              Reply(stUSER,'Opening mail box '+Account+'...','USER '+Account);
             end;
            end;
  stUSER : begin // password
            if s[1]='-' then begin
             ShowMessage('Error while opening mailbox '+Account+#13#10+s);
             Reply(stQUIT,'Close connexion','QUIT');
            end else begin
             Reply(stPass,'Validate password','PASS '+Password);
            end;
           end;
  stPASS : begin // Status
            if s[1]='-' then begin
             showMessage('Invalide password :'+#13#10+s);
             Reply(stQUIT,'Close connexion','QUIT');
            end else begin
             Reply(stSTAT,'Get status','STAT');
            end;
           end;
  stSTAT : begin // Mail status
            if s[1]='-' then begin
             showMessage('Mailbox error '+#13#10+s);
             Reply(stQUIT,'Close connexion','QUIT');
            end else begin
             MsgCount:=MailCount;
             if MsgCount=0 then begin
              StatusBar.Panels.Items[1].Text:='no messages';
              Reply(stQUIT,'Close connexion','QUIT');
             end else begin
              StatusBar.Panels.Items[1].Text:=IntToStr(MsgCount)+' message(s)';
              ReadMsg:=1;
              Reply(stRETR,'Reading message...','RETR 1');
             // Reply(stLIST,'Get message list','LIST');
             end;
            end;
           end;
// not used !
  stUIDL : begin
         //   MsgList.Items.Add(s);
            Reply(stQUIT,'Close connexion','QUIT');
           end;
// not used !
  stLIST : begin // List messages
            if s[1]='-' then begin
             showMessage('Mailbox error '+#13#10+s);
             Reply(stQUIT,'Close connexion','QUIT');
            end else begin
             case s[1] of
              '+': StatusBar.Panels.Items[1].Text:=s;
              '.': Reply(stRETR,'Reading message...','RETR 1');
          //    else MsgList.Items.Add(s);
             end;
           end;
          end;
  stRETR : begin // Retrieve Message
            if s[1]='-' then begin
             showmessage('Message error '+#13#10+s);
             Reply(stQUIT,'Close connexion','QUIT');
            end else
             Status:=stHEAD;
             MsgHead.Clear;
             MsgData.Clear;
             Message.Clear;
             statusBar.Panels.Items[0].Text:='Reading'+Copy(s,4,length(s));
           end;
  stHEAD : begin // Message Header
            if s='' then
             Status:=stDATA
            else
             MsgHead.Add(s);
           end;
  stDATA : begin // Message Data
            if s[1]='.' then begin
             RegisterMsg;
             if Supprimer.Checked then begin
              Reply(stDELE,'Removing message...','DELE '+IntToStr(ReadMsg));
             end else begin
              if ReadMsg<MsgCount then begin
               inc(ReadMsg);
               Reply(stRETR,'Reading message...','RETR '+IntToStr(ReadMsg));
              end else
               Reply(stQUIT,'Close connexion','QUIT')
             end;
            end else
             MsgData.Add(s);
           end;
  stDELE : begin
            if s[1]='-' then ShowMessage('Delete error');
            if ReadMsg<MsgCount then begin
             inc(ReadMsg);
             Reply(stRETR,'Reading message...','RETR '+IntToStr(ReadMsg));
            end else
             Reply(stQUIT,'Close connexion','QUIT')
           end;
  stQUIT : begin
            StatusBar.Panels.Items[0].Text:='Ready.';
            MsgListClick(Self);
           end;
 end;

 end;
end;

procedure TPOP3.pop3SocketClose(Sender: TObject; ASocket: Integer);
begin
// Memo1.Lines.Add('Receive close on socket '+IntToStr(ASocket));
 pop3Socket.Active:=False;
end;

procedure TPOP3.OptionsClick(Sender: TObject);
begin
 try
  ConfigForm:=TConfigForm.Create(Application);
  ConfigForm.ConfigPOP3.Show;
  ConfigForm.ShowModal;
 finally
  ConfigForm.Free;
 end;

end;

procedure TPOP3.FormCreate(Sender: TObject);
begin
 MsgList.Rows[0].add('From');
 MsgList.Rows[0].add('Subject');
 MsgList.Rows[0].add('Date');
 MsgHead:=TStringList.Create;
 MsgData:=TStringList.Create;
end;

procedure TPOP3.MsgListClick(Sender: TObject);
var
 text:TStringList;
begin
 text:=MsgList.Objects[1,msgList.Row] as TStringList;
 if text<>nil then Message.Lines.Assign(Text);
end;

procedure TPOP3.About1Click(Sender: TObject);
begin
 ShowMessage('EMail by Paul TOTH'+#13#10+
             '(101350.2175@Compuserve.com');
end;

procedure TPOP3.SpeedButton3Click(Sender: TObject);
begin
 if SMTP=nil then SMTP:=TSMTP.Create(Application);
 SMTP.show;
end;

procedure TPOP3.SpeedButton4Click(Sender: TObject);
Var
 Text:TStringList;
begin
 Message.Clear;
 Message.Lines.Add('< head >');
 Text:=MsgList.Objects[0,MsgList.Row] as TStringList;
 if Text<>nil then Message.Lines.AddStrings(Text);
 Message.Lines.add('< data >');
 Text:=MsgList.Objects[1,MsgList.Row] as TStringList;
 if Text<>nil then Message.Lines.AddStrings(Text);
 Message.Lines.add('< end >');
end;

end.
